Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 471512 - www-servers/apache: add ALPN (was NPN) patch from upstream to mod_ssl
Summary: www-servers/apache: add ALPN (was NPN) patch from upstream to mod_ssl
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All All
: Normal enhancement (vote)
Assignee: Lars Wendler (Polynomial-C)
URL: https://issues.apache.org/bugzilla/sh...
Whiteboard:
Keywords:
Depends on:
Blocks: 412451 471592
  Show dependency tree
 
Reported: 2013-05-28 00:20 UTC by SpanKY
Modified: 2015-06-01 06:08 UTC (History)
10 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
Adds Next Protocol Negotiation to mod_ssl (apache 2.4) (apache24_mod_ssl_npn.patch,9.01 KB, patch)
2013-08-05 11:37 UTC, Alexander Graf
Details | Diff
Adds Next Protocol Negotiation to mod_ssl (apache 2.2) (apache22_mod_ssl_npn.patch,9.11 KB, patch)
2013-08-05 11:38 UTC, Alexander Graf
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description SpanKY gentoo-dev 2013-05-28 00:20:23 UTC
upstream apache has added NPN to mod_ssl.  can we backport this to the 2.2.x and 2.4.x releases ?  mod_spdy needs it to work properly.
Comment 1 SpanKY gentoo-dev 2013-05-28 00:47:27 UTC
in case it helps, the mod_spdy guys maintain a patch that works fine against 2.2.24:
https://code.google.com/p/mod-spdy/source/browse/trunk/src/scripts/mod_ssl_with_npn.patch
Comment 2 Alexander Graf 2013-08-05 11:37:57 UTC
Created attachment 355168 [details, diff]
Adds Next Protocol Negotiation to mod_ssl (apache 2.4)

I've created to patches (for apache2.2 and apache2.4 respectively) which work fine in my setup. I've also fixed a small error in protocol negotiation.

The patches could be included into the gentoo-apache-2.x.tar.bz2 as
patches/05_all_mod_ssl_npn.patch
Comment 3 Alexander Graf 2013-08-05 11:38:14 UTC
Created attachment 355170 [details, diff]
Adds Next Protocol Negotiation to mod_ssl (apache 2.2)
Comment 4 Alexander Graf 2013-08-05 12:01:03 UTC
sorry, I forgot to mention.
the error in advertisement string generation is this one:
https://issues.apache.org/bugzilla/show_bug.cgi?id=55356
Comment 5 SpanKY gentoo-dev 2015-05-24 12:05:14 UTC
repurposing here since NPN has since been sunset in favor of ALPN

apache has merged ALPN into trunk's mod_ssl, but not the 2.4 branch (no idea why).  the mod_h2 project (which replaces mod_spdy) maintains a small patch for it here:
https://github.com/icing/mod_h2/tree/master/sandbox/httpd/patches

only need the httpd-alpn-unified.diff.patch file